import { useEffect, useRef } from 'rax';

function clearTimer(id) {
  if (id != null) clearInterval(id);
}

export default function useInterval(fn, delay) {
  var ref = useRef(); // Update to the latest function.

  useEffect(function () {
    ref.fn = fn;
  }, [fn]);
  useEffect(function () {
    // Clear before timer if delay time updated
    clearTimer(ref.id);

    if (typeof delay === 'number') {
      ref.id = setInterval(function () {
        return ref.fn();
      }, delay);
      return function () {
        return clearTimer(ref.id);
      };
    }
  }, [delay]);
}