"use strict";

exports.__esModule = true;
exports.default = useInterval;

var _rax = require("rax");

function clearTimer(id) {
  if (id != null) clearInterval(id);
}

function useInterval(fn, delay) {
  var ref = (0, _rax.useRef)(); // Update to the latest function.

  (0, _rax.useEffect)(function () {
    ref.fn = fn;
  }, [fn]);
  (0, _rax.useEffect)(function () {
    // Clear before timer if delay time updated
    clearTimer(ref.id);

    if (typeof delay === 'number') {
      ref.id = setInterval(function () {
        return ref.fn();
      }, delay);
      return function () {
        return clearTimer(ref.id);
      };
    }
  }, [delay]);
}